 @program prog_code,prog_name
;***************************************;
 include  SUPERCAR.H
writestr MACRO
 move.w  \3,-(a7)
 pea     \4(PC)
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     romlib[puttext]
 lea    10(a7),a7
 ENDM
;***************************************;
prog_code:
 move.l  #9680,-(a7)			;y a ti 9680 octets ? (352*220 pixels)
 jsr     romlib[create_handle]
 lea     4(a7),a7
 tst.w   d0
 beq     MEM_ERROR			;non=>pas de supercar !!!
 move.w  d0,hnum
 handle_ptr d0,a0
 move.l  a0,hptr

 bsr     loadlevel			;Charge le circuit dans le handle (le dcompresse)

 move.w  #$0700,d0
 trap    #1
 move.l  $64,oldint#1
 bclr.b  #2,$600001
 move.l  #newint#1,$64
 bset.b  #2,$600001
 trap    #1


;**dessine cadre+chanes de caractres**;
 lea     LCD_MEM,a0
 move.w  #959,d0
\clrs:
 clr.l   (a0)+
 dbra    d0,\clrs
 move.w  #127,-(a7)
 move.w  #239,-(a7)
 move.w  #0,-(a7)
 move.w  #144,-(a7)
 jsr     flib[frame_rect]
 lea     8(a7),a7
 move.w  #0,-(a7)			;fonte texte #0
 jsr     romlib[set_font]
 lea     2(a7),a7
 writestr #148,#46,#4,timemsg1
 writestr #148,#66,#4,timemsg2
 writestr #148,#86,#4,bestmsg1
 writestr #148,#106,#4,bestmsg2
 writestr #150,#10,#4,title
 move.w  #2,-(a7)			;fonte texte #2
 jsr     romlib[set_font]
 lea     2(a7),a7

;*****initialisation des variables******;
 lea     costab(PC),a0
 move.l  a0,cos_ptr      
 move.w  #0,xecran
 move.w  #0,yecran
 move.w  #2,vitesse
 move.w  #3,braquage
 move.w  #0,timer
 move.w  #0,timeflag
 move.b  #0,lapflag
 move.b  #0,borneflag
 move.w  #9999,best1
 affiche_last_time
 affiche_best1
 affiche_best2

MAIN:
;*****************ROTATION**************;
 move.w  braquage,d0
 btst.b  #4,keystat			;fleche gauche ?
 bne     noleft
 sub.w   d0,angle			;angle-d0
 tst.w   angle
 bge     noleft
 add.w   #360,angle			;modulo 2 pi
noleft:
 btst.b  #6,keystat			;fleche droite ?
 bne     noright
 add.w   d0,angle			;angle+d0
 cmp     #360,angle
 blt     noright
 sub.w   #360,angle			;modulo 2 pi
noright:


 bsr     getkeystat
 btst.b  #3,keystat			;LOCK enfonce ?
 bne     PASBOUGE			;non=>on avance pas
;********change les coordonnes*********;
 move.w  angle,d0
 clr.l   d1
 move.l  cos_ptr,a0
a0_90
 cmp     #90,d0
 bgt     a90_180
 move.b  0(a0,d0),d1
 mulu    vitesse,d1
 add.w   d1,x				;x=x+cos(angle)
 clr.l   d1
 move.w  #90,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 add.w   d1,y				;y=y+sin(angle)
 bra     afin
a90_180:
 cmp     #180,d0
 bgt     a180_270
 move.w  #180,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 sub.w   d1,x
 clr.l   d1
 move.w  d0,d2
 sub.w   #90,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 add.w   d1,y
 bra     afin
a180_270:
 cmp     #270,d0
 bgt     a270_360
 move.w  d0,d2
 sub.w   #180,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 sub.w   d1,x
 clr.l   d1
 move.w  #270,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 sub.w   d1,y
 bra     afin
a270_360:
 move.w  #360,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 add.w   d1,x
 clr.l   d1
 move.w  d0,d2
 sub.w   #270,d2
 move.b  0(a0,d2),d1
 mulu    vitesse,d1
 sub.w   d1,y
afin:


PASBOUGE:
 cmp     #0,x				;(x,y) sur l'cran ?
 bgt     c1				;si non, on y remdie.
 move.w  #0,x
c1:
 cmp     #343*64,x
 blt     c2
 move.w  #343*64,x
c2:
 cmp     #0,y
 bgt     c3
 move.w  #0,y
c3:
 cmp     #211*64,y
 blt     c4
 move.w  #211*64,y
c4:
;********passage d'une ligne************;
 move.w  x,d0
 lsr.w   #6,d0
 move.w  y,d1
 lsr.w   #6,d1

 move.w  lastx,d2
 lsr.w   #6,d2
 move.w  lasty,d3
 lsr.w   #6,d3
 move.w  x,lastx			;remet  jour lastx et lasty
 move.w  y,lasty

 cmp     d0,d2
 bne     bouge_ok
 cmp     d1,d3
 bne     bouge_ok
 bra     paspasse
bouge_ok:
 lea     lapline(PC),a1
 move.w  curline,d4
 lsl.w   #3,d4
 add.w   d4,a1
 clr.l   d4

 lea     coord(PC),a0			;charge les 4 pts dans coord
 move.w  (a1)+,(a0)+			;a.x 1er pt de la ligne
 move.w  (a1)+,(a0)+			;a.y
 move.w  (a1)+,(a0)+			;b.x 2eme pt de la ligne
 move.w  (a1)+,(a0)+			;b.y
 move.w  d2,(a0)+			;c.x position prcdente de la voiture
 move.w  d3,(a0)+			;c.y
 move.w  d0,(a0)+			;d.x nouvelle position
 move.w  d1,(a0)+			;d.y
 bsr     checkpass
 tst.b   borneflag
 beq     paspasse
 add.w   #1,curline
 cmp     #3,curline			;passe contrle ou ligne d'arrive ?
 bne     JustPassControl
 clr.w   curline
 move.b  #1,lapflag
JustPassControl:
 clr.b   borneflag
paspasse:
;***************************************;
 move.l  d4,-(a7)
 bsr     getpixel			;hors-piste ?
 tst.b   d4
 beq     pas_sur_l_herbe
 move.w  #15000,d4			;oui=>delay
\dl:
 nop
 dbra    d4,\dl
pas_sur_l_herbe:
 move.l  (a7)+,d4

 bsr     getbg
 lea     auto(PC),a0
 bsr     put8x8sprite
;********* affiche l'cran *************;
 movem.l d0-d1,-(a7)
 sub.w   #72,d0
 sub.w   #63,d1
;vrifie les coordonns
 cmp     #0,d0
 bge     ok1
 move.w  #0,d0
ok1:
 cmp     #352-144,d0
 ble     ok2
 move.w  #352-144,d0
ok2:
 cmp     #0,d1
 bge     ok3
 move.w  #0,d1
ok3:
 cmp     #220-128,d1
 ble     ok4
 move.w  #220-128,d1
ok4:
 move.w  d0,xecran
 move.w  d1,yecran
 bsr     puthandle			;affiche le tout  l'cran
 movem.l (a7)+,d0-d1
 bsr     putbg				;efface tout de suite la voiture dans le handle
;********* affiche les temps ***********;
 ;CURRENT TIME
 affiche_current_time
 tst.b   timeflag			;timeflag<>0 ?
 bne     NORMAL_EXIT			;oui=>on quitte (timer a expir)

 tst.b   lapflag
 beq     le_tour_il_est_pas_encore_fini
 move.w  timer,d7
 move.w  d7,lasttime
 affiche_last_time
 cmp     best1,d7			;best1 battu ?
 bge     pasrecord
 move.w  d7,best1
 affiche_best1
 cmp     best2,d7			;best2 battu ?
 bge     pasrecord
 move.w  d7,best2			;oui=>on le stocke
 move.l  best2_addr,a0
 move.w  d7,(a0)
 affiche_best2
pasrecord:
 clr.w   timer
 clr.b   lapflag
le_tour_il_est_pas_encore_fini:
 btst.b  #6,keystat+8			;ESC ?
 bne     MAIN				;non => on continue

NORMAL_EXIT:
 ;remet l'ancienne int1 en place
 move.w  #$0700,d0
 trap    #1
 bclr.b  #2,$600001
 move.l  oldint#1(pc),$64
 bset.b  #2,$600001
 trap    #1
LEVEL_ERROR:
debug:
 ;libre mmoire
 move.w  hnum,-(a7)
 jsr     romlib[destroy_handle]
 addq	 #2,a7
MEM_ERROR:
 rts

;****************FONCTIONS**************;
puthandle:   ;(d0,d1)=(x,y)
 movem.l d0-d7/a0-a1,-(a7)
 move.l  #$4440,a0
 move.l  hptr,a1

 move.w  d1,d2				;multiplie y par 44 (44 octets dans une ligne du handle)
 lsl.w   #2,d1				;4y
 move.w  d1,d2
 lsl.w   #1,d2				;2*4y
 move.w  d2,d3
 lsl.w   #2,d3				;4*8y
 add.w   d3,d2				;32y+8y=40y
 add.w   d2,d1				;40y+4y=44y
 add.l   d1,a1				;et ajoute 44y  a1

 move.w  d0,d2				;deplacement x en word
 lsr.w   #3,d2				;div 8
 and.w   #$FFFE,d2			;supprime bit 1
 add.l   d2,a1
 move.w  d0,d2				;dplacement par rapport au plus proche word
 and.w   #%1111,d2			;garde bits 1-4 (0-15)
 cmp     #8,d2
 bgt     suite2
suite1:
 move.w  #$FFFF,d3			; #%1111111111111111
 lsl.w   d2,d3				; #%1111111111100000  <-
 lsr.w   d2,d3				; #%0000011111111111  ->
 move.w  d3,d4
 not.w   d4				; #%1111100000000000
 move.w  #127,d7			;lignes balayes-1
nextline1:
 move.w  #8,d6
nextword1:
 move.w  (a1)+,d0
 move.w  (a1),d1
 and.w   d3,d0
 and.w   d4,d1
 rol.w   d2,d0
 rol.w   d2,d1
 add.w   d1,d0
 move.w  d0,(a0)+
 dbra    d6,nextword1
 add.l   #26,a1
 add.l   #12,a0
 dbra    d7,nextline1
 bra     fin
suite2:
 move.w  #16,d3
 sub.w   d2,d3
 move.w  d3,d2
 move.w  #$FFFF,d4			; #%1111111111111111
 lsl.w   d2,d4				; #%1111111111100000  <-
 move.w  d4,d3
 not.w   d3				; #%0000000000011111
 move.w  #127,d7			;lignes balayes-1
nextline2:
 move.w  #8,d6
nextword2:
 move.w  (a1)+,d0
 move.w  (a1),d1
 and.w   d3,d0
 and.w   d4,d1
 ror.w   d2,d0
 ror.w   d2,d1
 add.w   d1,d0
 move.w  d0,(a0)+
 dbra    d6,nextword2
 add.l   #26,a1
 add.l   #12,a0
 dbra    d7,nextline2
fin:
 movem.l (a7)+,d0-d7/a0-a1
 rts



;***************************************;
convstr:
 movem.l d0-d2,-(a7)
 clr.b   (a0)
repconv:
 divu    #10,d0
 move.l  d0,d2
 swap    d2
 add.b   #48,d2
 move.b  d2,-(a0)
 subq    #1,d1
 and.l   #$FFFF,d0
 bne     repconv
 tst.w   d1
 beq     CS_Done
 subq    #1,d1
FillOut:
 move.b  #48,-(a0)
 dbra    d1,FillOut
CS_Done:
 movem.l (a7)+,d0-d2
 rts

getkeystat:
 movem.l d0-d1/a0,-(a7)
 lea     keystat(PC),a0
 move.w  #$FFFE,d0
 moveq   #9,d1
GetKeys:
 move.w  d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 move.b  $60001B,(a0)+
 rol.w	 #1,d0
 dbra    d1,GetKeys
 movem.l (a7)+,d0-d1/a0
 rts


;***************************************;
getbg:  ;(d0,d1)=(x,y)
 movem.l d0-d2/a0-a1,-(a7)
 move.l  hptr,a1
 lea     autobg(PC),a0

 move.w  d1,d2				;multiplie y par 44 (44 octets dans une ligne du handle)
 lsl.w   #2,d1
 move.w  d1,d2
 lsl.w   #1,d2
 move.w  d2,d3
 lsl.w   #2,d3
 add.w   d3,d2
 add.w   d2,d1
 add.l   d1,a1				;et ajoute 44y  a1

 move.w  d0,d2				;deplacement x en word
 lsr.w   #3,d2
 add.l   d2,a1				;ajoute  a1
 move.b  #7,d2
\gnl:
 move.b  (a1)+,(a0)+
 move.b  (a1)+,(a0)+
 add.l   #42,a1
 dbra    d2,\gnl
 movem.l (a7)+,d0-d2/a0-a1
 rts


;***************************************;
putbg:  ;(d0,d1)=(x,y)
 movem.l d0-d2/a0-a1,-(a7)
 move.l  hptr,a1
 lea     autobg(PC),a0

 move.w  d1,d2				;multiplie y par 44
 lsl.w   #2,d1
 move.w  d1,d2
 lsl.w   #1,d2
 move.w  d2,d3
 lsl.w   #2,d3
 add.w   d3,d2
 add.w   d2,d1
 add.l   d1,a1				;et ajoute 44y  a1

 move.w  d0,d2				;deplacement x en word
 lsr.w   #3,d2				;div 8
 add.l   d2,a1				;ajoute  a1
 move.w  #7,d2
\pnl:
 move.b  (a0)+,(a1)+
 move.b  (a0)+,(a1)+
 add.l   #42,a1
 dbra    d2,\pnl
 movem.l (a7)+,d0-d2/a0-a1
 rts



;***************************************;
getpixel:				;(d0,d1)=(x,y) sortie:bit  d2
 movem.l d0-d3/a1,-(a7)
 add.w   #4,d0
 add.w   #4,d1
 move.l  hptr,a1
 move.w  d1,d2
 lsl.w   #2,d1
 move.w  d1,d2
 lsl.w   #1,d2
 move.w  d2,d3
 lsl.w   #2,d3
 add.w   d3,d2
 add.w   d2,d1
 add.l   d1,a1				;a1=a1+44y

 move.w  d0,d2
 lsr.w   #3,d2
 add.l   d2,a1

 move.w  d0,d2				;dplacement par rapport au plus proche word
 and.w   #%111,d2			;garde bits 1-4 (0-15)
 move.b  #7,d1
 sub.b   d2,d1
 move.b  (a1),d0
 btst.b  d1,d0
 beq     getblanc
getnoir:        
 move.b  #1,d4
 movem.l (a7)+,d0-d3/a1
 rts
getblanc:        
 move.b  #0,d4
 movem.l (a7)+,d0-d3/a1
 rts


;**************************;
put8x8sprite:				;a0:pointe sur structure 16 bytes, (d0,d1)=(x,y)
 movem.l d0-d4/a1,-(a7)
 move.l  hptr,a1

 move.w  d1,d2
 lsl.w   #2,d1
 move.w  d1,d2
 lsl.w   #1,d2
 move.w  d2,d3
 lsl.w   #2,d3
 add.w   d3,d2
 add.w   d2,d1
 add.l   d1,a1				;a1=a1+44y

 move.w  d0,d2
 lsr.w   #3,d2
 add.l   d2,a1

 move.w  #7,d2
 and.w   #%111,d0			;garde bits 1-3 (0-7)
 sub.w   d0,d2

 move.w  #7,d4
\nb:
 clr.w   d0
 clr.w   d1
 move.b  8(a0),d1			;masque
 lsl.w   d2,d1
 move.b  (a0)+,d0			;sprite
 lsl.w   d2,d0
 not.w   d1
 rol.w   #8,d0				;hi(d0)<=>lo(d0)
 rol.w   #8,d1				;hi(d1)<=>lo(d1)

 move.b  (a1),d3			;fond octet haut (1er)
 and.b   d1,d3
 or.b    d0,d3
 move.b  d3,(a1)+

 lsr.w   #8,d0
 lsr.w   #8,d1

 move.b  (a1),d3			;fond octet bas (2nd)
 and.b   d1,d3
 or.b    d0,d3
 move.b  d3,(a1)+

 add.l   #42,a1				;ligne suivante
 dbra    d4,\nb
 movem.l (a7)+,d0-d4/a1
 rts


;**************************;
loadlevel:				;D0:handle du circuit
 movem.l d0-d7/a0-a1,-(a7)
 lea     circuit(PC),a0
 move.l  hptr,a1			;handle destination (circuit dcompress, prt  tre affich)
 
 clr.l   d0
 clr.l   d7
 move.w  (a0)+,d7			;lit la taille (en word)
 sub.w   #1,d7

 moveq   #1,d2				;couleur de dpart (noir)
 clr.w   d0
 moveq   #15,d3				;compteur des pixels

Nouvelle_Couleur:
 move.w  (a0)+,d6			;lit nb pixels conscutifs ^m couleur
 sub.w   #1,d6
Pixel_Suivant:				;dessine tous les pixels conscutifs d'une mme couleur
 cmp     #0,d3				;pixel suivant pas dans mme word ?
 bne     toujours_m_word		;non=>toujours_m_word
 moveq   #16,d3				;oui, word suivant :
 move.w  d0,(a1)+
 clr.w   d0
toujours_m_word:
 sub.w   #1,d3				;pixel suivant.
 cmp     #0,d2				;pixel  effacer ?
 beq     pixel_blanc
 bset.w  d3,d0
 pixel_blanc:
 dbra    d6,Pixel_Suivant
 eori.b  #1,d2				;chgt de couleur 1<=>0    
 dbra    d7,Nouvelle_Couleur

 lea     lapline(PC),a1			;lit les contrles  : 4*((x1,y1)(x2,y2))
 moveq   #11,d2
readlapline:
 move.w  (a0)+,(a1)+
 dbra    d2,readlapline

 move.w  (a0)+,x
 move.w  (a0)+,y
 move.w  (a0)+,angle

 move.l  a0,best2_addr
 move.w  (a0)+,best2			;meilleur temps sur ce circuit
EndLoad:
 movem.l (a7)+,d0-d7/a0-a1
 rts



;******************PASSAGE ENTRE DEUX BORNES*******************;


checkpass:
 movem.l d0-d7/a0,-(a7)
 lea     coord(PC),a0			;a0 pointe sur les coordonnes des pts
;DET(AB,AC) = ab*ac*sin(AB,AC)
 move.w  4(a0),d1			;b.x
 sub.w   (a0),d1			;-a.x
 move.w  10(a0),d7			;c.y
 sub.w   2(a0),d7			;-a.y
 muls    d7,d1				;d1.l=(b.x-a.x)*(c.y-a.y)
 move.w  6(a0),d7			;b.y
 sub.w   2(a0),d7			;-a.y
 move.w  8(a0),d6			;c.x
 sub.w   (a0),d6			;-a.x
 muls    d6,d7				;d7.l=(b.y-a.y)*(c.x-a.x)
 sub.l   d7,d1				;d1=Ka1
;DET(AD,AB) = ab*ac*sin(AD,AB)
 move.w  12(a0),d2			;d.x
 sub.w   (a0),d2			;-a.x
 move.w  6(a0),d7			;b.y
 sub.w   2(a0),d7			;-a.y
 muls    d7,d2				;d2.l=(d.x-a.x)*(b.y-a.y)
 move.w  14(a0),d7			;d.y
 sub.w   2(a0),d7			;-a.y
 move.w  4(a0),d6			;b.x
 sub.w   (a0),d6			;-a.x
 muls    d6,d7				;d7.l=(d.y-a.y)*(b.x-a.x)
 sub.l   d7,d2				;d2=Ka2
;DET(CA,CD) = ab*ac*sin(CA,CD)
 move.w  (a0),d3			;a.x
 sub.w   8(a0),d3			;-c.x
 move.w  14(a0),d7			;d.y
 sub.w   10(a0),d7			;-c.y
 muls    d7,d3				;d3.l=(a.x-c.x)*(d.y-c.y)
 move.w  2(a0),d7			;a.y
 sub.w   10(a0),d7			;-c.y
 move.w  12(a0),d6			;d.x
 sub.w   8(a0),d6			;-c.x
 muls    d6,d7				;d7.l=(a.y-c.y)*(d.x-c.x)
 sub.l   d7,d3				;d3=Ka3
;DET(CD,CB) = ab*ac*sin(CD,CB)
 move.w  12(a0),d4			;d.x
 sub.w   8(a0),d4			;-c.x
 move.w  6(a0),d7			;b.y
 sub.w   10(a0),d7			;-c.y
 muls    d7,d4				;d4.l=(d.x-c.x)*(b.y-c.y)
 move.w  14(a0),d7			;d.y
 sub.w   10(a0),d7			;-c.y
 move.w  4(a0),d6			;b.x
 sub.w   8(a0),d6			;-c.x
 muls    d6,d7				;d7.l=(d.y-c.y)*(b.x-c.x)
 sub.l   d7,d4				;d4=Ka4

 clr.b   borneflag
 cmp.l   #0,d1
 ble     \PasPasse
 cmp.l   #0,d2
 ble     \PasPasse
 cmp.l   #0,d3
 ble     \PasPasse
 cmp.l   #0,d4
 ble     \PasPasse
 move.b  #1,borneflag			;si les 4 Ka sont >0, les segments se coupent
\PasPasse:
 movem.l (a7)+,d0-d7/a0
 rts
;*********NOUVELLE INTERRUPTION #1******;

newint#1:
 cmp     #9999,timer
 bne     ni1s
 move.b  #1,timeflag
 rte
ni1s:
 add.w   #1,timer
 rte

;*************VARIABLES*****************;
oldint#1 dc.l 0
cos_ptr  dc.l 0
hptr     dc.l 0
best2_addr dc.l 0
x        dc.w 0
y        dc.w 0
lastx    dc.w 0
lasty    dc.w 0
hnum     dc.w 0
xecran   dc.w 0
yecran   dc.w 0
angle    dc.w 0
braquage dc.w 0
vitesse  dc.w 0
curline  dc.w 0
timer    dc.w 0
lasttime dc.w 0
best1    dc.w 0
best2    dc.w 0
borneflag dc.w 0
timeflag dc.b 0
lapflag  dc.b 0

error1   dc.b "YOU NEED ABOUT 9860 FREE BYTES",0,0
title    dc.b "ICI BIENTOT UN TITRE",0,0
credit   dc.b "-by Th.FERNIQUE  1997-",0,0
timemsg1 dc.b "LAST TIME :",0
timemsg2 dc.b "CURRENT TIME :",0,0
bestmsg1 dc.b "BEST TIME 1 :",0
bestmsg2 dc.b "BEST TIME 2 :",0
loading  dc.b "Chargement du circuit...",0,0

lapline  ds.w 12
str      ds.b 8
strend
coord    ds.w 8
keystat  ds.b 10
autobg   ds.b 16

auto:
 dc.b %00000000
 dc.b %00111100
 dc.b %01101110
 dc.b %01000110
 dc.b %01101110
 dc.b %01111110
 dc.b %00111100
 dc.b %00000000

 dc.b %00111100
 dc.b %01111110
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %01111110
 dc.b %00111100

prog_name: dc.b "SUPERCAR by Th.FERNIQUE",0
costab:   INCBIN costab.bin
a dc.l 0
circuit:
 INCBIN circ01.bin
; INCBIN circ02.bin
; INCBIN circ03.bin
;*************** End of Fargo program ****************

 reloc_open
 add_library romlib
 add_library flib
 reloc_close
 end
